﻿using Avalonia.Controls.ApplicationLifetimes;
using AvaloniaApplication2.Models;
using CommunityToolkit.Mvvm.ComponentModel;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Avalonia;
using Avalonia.Platform.Storage;
using Avalonia.Media.Imaging;
using System.IO;

namespace AvaloniaApplication2.ViewModels
{
   public partial class Page2ViewModel : ViewModelBase
    {
        [ObservableProperty] Logined editedLogined;
        [ObservableProperty] List<Gender> gendersList;
        [ObservableProperty] Bitmap imageUser;

        public Page2ViewModel()
        {
            GendersList = db.Genders.ToList();
            editedLogined = new Logined(){ User = new User { IdGenderNavigation = new Gender() }, IdRole=2 };
        }

            public Page2ViewModel(int id) 
        {
            GendersList = db.Genders.ToList();
            editedLogined = db.Logineds.Include(x=>x.User.IdTraits).Include(x=>x.User.IdGenderNavigation).FirstOrDefault(x=>x.Id == id);
            imageUser = EditedLogined.User.Image != null ? new Bitmap(new MemoryStream(editedLogined.User.Image)) : new Bitmap("Assets/заглушка.jpg");
        }
        public DateTimeOffset DateTimeOffset
        {
            get => new DateTimeOffset((DateTime)EditedLogined.User.BirthDate, TimeSpan.Zero);
            set => EditedLogined.User.BirthDate = new DateTime(value.Year, value.Month, value.Day);
        }

        public void GoBack() => MainWindowViewModel.Self.Page = new Page1();

        public void Save()
        {
            if (EditedLogined.Id==0) db.Logineds.Add(EditedLogined);
            db.SaveChanges();
        }

      


        public async Task Image()
        {
            if (Application.Current?.ApplicationLifetime is not IClassicDesktopStyleApplicationLifetime desktop ||
                desktop.MainWindow?.StorageProvider is not { } provider)
                throw new NullReferenceException("Missing StorageProvider instance.");

            //инициализация в явном виде. менее трушный путь
            //IClassicDesktopStyleApplicationLifetime desktop = (IClassicDesktopStyleApplicationLifetime)Application.Current?.ApplicationLifetime;
            // IStorageProvider provider = desktop.MainWindow?.StorageProvider;
            var files = await provider.OpenFilePickerAsync(new FilePickerOpenOptions()
            {
                Title = "Выберите файл с изображением пользователя",
                AllowMultiple = false               
            });
            await using var readStream = await files[0].OpenReadAsync();
            byte[] buffer = new byte[10000000];
            var bytes = readStream.ReadAtLeast(buffer, 1);
            Array.Resize(ref buffer,bytes);
            EditedLogined.User.Image = buffer;
            ImageUser = new Bitmap(new MemoryStream(EditedLogined.User.Image));
            db.SaveChanges();
        }

     
    }
}
